searchNodes=[{"type":"behaviour","title":"Cache","doc":"ElixirCache The goal of this project is to unify Cache APIs and make Strategies easy to implement and sharable across all storage types/adapters The second goal is to make sure testing of all cache related funciions is easy, meaning caches should be isolated per test and not leak their state to outside tests Installation The package can be installed by adding elixir_cache to your list of dependencies in mix.exs : def deps do [ { :elixir_cache , &quot;~&gt; 0.1.0&quot; } ] end The docs can be found at https://hexdocs.pm/elixir_cache . Usage defmodule MyModule do use Cache , adapter : Cache.Redis , name : :my_name , sandbox? : Mix . env ( ) === :test , opts : [ ... opts ] end In our application.ex children = [ { Cache , [ MyModule ] } ] Now we can use MyModule to call various Cache apis MyModule . get ( &quot;key&quot; ) #&gt; {:ok, nil} MyModule . put ( &quot;key&quot; , &quot;value&quot; ) #&gt; :ok MyModule . get ( &quot;key&quot; ) #&gt; {:ok, &quot;value&quot;} Adapters Cache.Agent - Simple agent based caching Cache.DETS - Disk persisted caching with dets Cache.ETS - Super quick in-memory cache with ets Cache.Redis - Caching adapter using Redix &amp; Poolboy , supports Redis JSON an Redis Hashes Cache.ConCache - Wrapper around ConCache library Adapter Specific Functions Some adapters have specific functions such as redis which has hash functions and pipeline functions to make calls easier. These adapter when used will add extra commands to your cache module. Sandboxing Our cache config accepts a sandbox?: boolean . In sandbox mode, the Cache.Sandbox adapter will be used, which is just a simple Agent cache unique to the root process. The Cache.SandboxRegistry is responsible for registering test processes to a unique instance of the Sandbox adapter cache. This makes it safe in test mode to run all your tests asynchronously! For test isolation via the Cache.SandboxRegistry to work, you must start the registry in your setup, or your test_helper.exs: # test/test_helper.exs + Cache.SandboxRegistry . start_link ( ) ExUnit . start ( ) Then inside our setup for a test we can do: Cache.SandboxRegistry . start ( [ MyCache , CacheItem ] ) Creating Adapters Adapters are very easy to create in this model and are basically just a module that implement the @behaviour Cache This behaviour adds the following callbacks put ( cache_name , key , ttl , value , opts \\\\ [ ] ) get ( cache_name , key , opts \\\\ [ ] ) delete ( cache_name , key , opts \\\\ [ ] ) opts_definition ( ) # NimbleOptions definition map child_spec ( { cache_name , cache_opts } ) Cache.ETS is probably the easiest adapter to follow as a guide as it's a simple Task Runtime Configuration Adapter configuration can also be specified at runtime. These options are first passed to the adapter child_spec when starting the adapter and then passed to all runtime function calls. For example: # Configure with Module Function defmodule Cache.Example do use Cache , adapter : Cache.Redis , name : :test_cache_redis , opts : { Cache.Example , :opts , [ ] } def opts , do : [ host : &quot;localhost&quot; , port : 6379 ] end # Configure with callback function defmodule Cache.Example do use Cache , adapter : Cache.Redis , name : :test_cache_redis , opts : &amp; Cache.Example . opts / 0 def opts , do : [ host : &quot;localhost&quot; , port : 6379 ] end # Fetch from application config # config :elixir_cache, Cache.Example, [] defmodule Cache.Example do use Cache , adapter : Cache.Redis , name : :test_cache_redis , opts : :elixir_cache end # Fetch from application config # config :elixir_cache, :cache_opts, [] defmodule Cache.Example do use Cache , adapter : Cache.Redis , name : :test_cache_redis , opts : { :elixir_cache , :cache_opts } end Runtime options can be configured in one of the following formats: {module, function, args} - Module, function, args {application_name, key} - Application name. This is called as Application.fetch_env!(application_name, key) . application_name - Application name as an atom. This is called as Application.fetch_env!(application_name, cache_module}) . function - Zero arity callback function. For eg. &amp;YourModule.options/0 [key: value_type] - Keyword list of options.","ref":"Cache.html"},{"type":"function","title":"Cache.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Cache.html#child_spec/1"},{"type":"callback","title":"Cache.child_spec/1","doc":"","ref":"Cache.html#c:child_spec/1"},{"type":"callback","title":"Cache.delete/2","doc":"","ref":"Cache.html#c:delete/2"},{"type":"callback","title":"Cache.delete/3","doc":"","ref":"Cache.html#c:delete/3"},{"type":"callback","title":"Cache.get/2","doc":"","ref":"Cache.html#c:get/2"},{"type":"callback","title":"Cache.get/3","doc":"","ref":"Cache.html#c:get/3"},{"type":"function","title":"Cache.get_or_create/3","doc":"","ref":"Cache.html#get_or_create/3"},{"type":"function","title":"Cache.init/1","doc":"Callback implementation for Supervisor.init/1 .","ref":"Cache.html#init/1"},{"type":"callback","title":"Cache.opts_definition/0","doc":"","ref":"Cache.html#c:opts_definition/0"},{"type":"callback","title":"Cache.put/4","doc":"","ref":"Cache.html#c:put/4"},{"type":"callback","title":"Cache.put/5","doc":"","ref":"Cache.html#c:put/5"},{"type":"callback","title":"Cache.start_link/1","doc":"","ref":"Cache.html#c:start_link/1"},{"type":"function","title":"Cache.start_link/2","doc":"","ref":"Cache.html#start_link/2"},{"type":"module","title":"Cache.Agent","doc":"This module is the Agent adapter. Very lightweight use only","ref":"Cache.Agent.html"},{"type":"function","title":"Cache.Agent.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Cache.Agent.html#child_spec/1"},{"type":"module","title":"Cache.ConCache","doc":"ETS Based cache https://github.com/sasa1977/con_cache Takes the following options: :acquire_lock_timeout ( pos_integer/0 ) - The default value is 5000 . :touch_on_read ( boolean/0 ) - The default value is false . :global_ttl - The default value is 1800000 . :ttl_check_interval - The default value is 60000 . :dirty? ( boolean/0 ) - Use dirty_put instead of locking to put, enabled by default The default value is true . :ets_options - https://www.erlang.org/doc/man/ets.html#new-2","ref":"Cache.ConCache.html"},{"type":"function","title":"Cache.ConCache.dirty_get_or_store/3","doc":"","ref":"Cache.ConCache.html#dirty_get_or_store/3"},{"type":"function","title":"Cache.ConCache.get_or_store/4","doc":"Implements a version of get_or_store that locks locally so only one process runs store_fun at a time. Any other processes that miss cache will wait for the first caller to finish store_fun then will read the result from cache.","ref":"Cache.ConCache.html#get_or_store/4"},{"type":"type","title":"Cache.ConCache.ets_option/0","doc":"","ref":"Cache.ConCache.html#t:ets_option/0"},{"type":"type","title":"Cache.ConCache.opts/0","doc":"","ref":"Cache.ConCache.html#t:opts/0"},{"type":"module","title":"Cache.DETS","doc":"DETS adapter so that we can use dets as a cache Options :ram_file ( boolean/0 ) - Enable RAM File The default value is false . :type - Data type of DETS cache The default value is :set . :file_path ( String.t/0 ) - File path to save DETS file at The default value is &quot;./&quot; .","ref":"Cache.DETS.html"},{"type":"function","title":"Cache.DETS.child_spec/1","doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Cache.DETS.html#child_spec/1"},{"type":"module","title":"Cache.ETS","doc":"ETS adapter so that we can use ets as a cache Options :write_concurrency ( boolean/0 ) - Enable write concurrency :read_concurrency ( boolean/0 ) - Enable read concurrency :decentralized_counters ( boolean/0 ) - Use decentralized counters :type - Data type of ETS cache The default value is :set . :compressed ( boolean/0 ) - Enable ets compression","ref":"Cache.ETS.html"},{"type":"function","title":"Cache.ETS.child_spec/1","doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Cache.ETS.html#child_spec/1"},{"type":"module","title":"Cache.Redis","doc":"This module interacts with redis using a pool of connections Options :uri ( String.t/0 ) - Required. The connection uri to redis :size ( pos_integer/0 ) - The amount of workers in the pool :max_overflow ( pos_integer/0 ) - The amount of max overflow the pool can handle :strategy - The type of queue to use for poolboy","ref":"Cache.Redis.html"},{"type":"function","title":"Cache.Redis.command/3","doc":"See Cache.Redis.Global.command/3 .","ref":"Cache.Redis.html#command/3"},{"type":"function","title":"Cache.Redis.command!/3","doc":"See Cache.Redis.Global.command!/3 .","ref":"Cache.Redis.html#command!/3"},{"type":"function","title":"Cache.Redis.hash_delete/4","doc":"See Cache.Redis.Hash.hash_delete/4 .","ref":"Cache.Redis.html#hash_delete/4"},{"type":"function","title":"Cache.Redis.hash_get/4","doc":"See Cache.Redis.Hash.hash_get/4 .","ref":"Cache.Redis.html#hash_get/4"},{"type":"function","title":"Cache.Redis.hash_get_all/3","doc":"See Cache.Redis.Hash.hash_get_all/3 .","ref":"Cache.Redis.html#hash_get_all/3"},{"type":"function","title":"Cache.Redis.hash_get_many/3","doc":"See Cache.Redis.Hash.hash_get_many/3 .","ref":"Cache.Redis.html#hash_get_many/3"},{"type":"function","title":"Cache.Redis.hash_scan/4","doc":"See Cache.Redis.Hash.hash_scan/4 .","ref":"Cache.Redis.html#hash_scan/4"},{"type":"function","title":"Cache.Redis.hash_set/6","doc":"See Cache.Redis.Hash.hash_set/6 .","ref":"Cache.Redis.html#hash_set/6"},{"type":"function","title":"Cache.Redis.hash_set_many/4","doc":"See Cache.Redis.Hash.hash_set_many/4 .","ref":"Cache.Redis.html#hash_set_many/4"},{"type":"function","title":"Cache.Redis.hash_values/3","doc":"See Cache.Redis.Hash.hash_values/3 .","ref":"Cache.Redis.html#hash_values/3"},{"type":"function","title":"Cache.Redis.json_array_append/5","doc":"See Cache.Redis.JSON.array_append/5 .","ref":"Cache.Redis.html#json_array_append/5"},{"type":"function","title":"Cache.Redis.json_clear/4","doc":"See Cache.Redis.JSON.clear/4 .","ref":"Cache.Redis.html#json_clear/4"},{"type":"function","title":"Cache.Redis.json_delete/4","doc":"See Cache.Redis.JSON.delete/4 .","ref":"Cache.Redis.html#json_delete/4"},{"type":"function","title":"Cache.Redis.json_get/4","doc":"See Cache.Redis.JSON.get/4 .","ref":"Cache.Redis.html#json_get/4"},{"type":"function","title":"Cache.Redis.json_incr/5","doc":"See Cache.Redis.JSON.incr/5 .","ref":"Cache.Redis.html#json_incr/5"},{"type":"function","title":"Cache.Redis.json_set/5","doc":"See Cache.Redis.JSON.set/5 .","ref":"Cache.Redis.html#json_set/5"},{"type":"function","title":"Cache.Redis.ms_to_nearest_sec/1","doc":"","ref":"Cache.Redis.html#ms_to_nearest_sec/1"},{"type":"function","title":"Cache.Redis.pipeline/3","doc":"See Cache.Redis.Global.pipeline/3 .","ref":"Cache.Redis.html#pipeline/3"},{"type":"function","title":"Cache.Redis.pipeline!/3","doc":"See Cache.Redis.Global.pipeline!/3 .","ref":"Cache.Redis.html#pipeline!/3"},{"type":"function","title":"Cache.Redis.pool_config/2","doc":"","ref":"Cache.Redis.html#pool_config/2"},{"type":"function","title":"Cache.Redis.scan/3","doc":"See Cache.Redis.Global.scan/3 .","ref":"Cache.Redis.html#scan/3"},{"type":"module","title":"Cache.Sandbox","doc":"This module is the adapter used by the SandboxRegistry to mock out all the other adapters therefore it must implement all features shared across all adapters. It uses a basic Agent and shouldn't be used in production. It's good for dev &amp; test to avoid needing dependencies","ref":"Cache.Sandbox.html"},{"type":"function","title":"Cache.Sandbox.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Cache.Sandbox.html#child_spec/1"},{"type":"function","title":"Cache.Sandbox.command/3","doc":"","ref":"Cache.Sandbox.html#command/3"},{"type":"function","title":"Cache.Sandbox.command!/3","doc":"","ref":"Cache.Sandbox.html#command!/3"},{"type":"function","title":"Cache.Sandbox.hash_delete/4","doc":"","ref":"Cache.Sandbox.html#hash_delete/4"},{"type":"function","title":"Cache.Sandbox.hash_get/4","doc":"","ref":"Cache.Sandbox.html#hash_get/4"},{"type":"function","title":"Cache.Sandbox.hash_get_all/3","doc":"","ref":"Cache.Sandbox.html#hash_get_all/3"},{"type":"function","title":"Cache.Sandbox.hash_get_many/3","doc":"","ref":"Cache.Sandbox.html#hash_get_many/3"},{"type":"function","title":"Cache.Sandbox.hash_scan/4","doc":"","ref":"Cache.Sandbox.html#hash_scan/4"},{"type":"function","title":"Cache.Sandbox.hash_set/6","doc":"","ref":"Cache.Sandbox.html#hash_set/6"},{"type":"function","title":"Cache.Sandbox.hash_set_many/4","doc":"","ref":"Cache.Sandbox.html#hash_set_many/4"},{"type":"function","title":"Cache.Sandbox.hash_values/3","doc":"","ref":"Cache.Sandbox.html#hash_values/3"},{"type":"function","title":"Cache.Sandbox.json_array_append/5","doc":"","ref":"Cache.Sandbox.html#json_array_append/5"},{"type":"function","title":"Cache.Sandbox.json_clear/4","doc":"","ref":"Cache.Sandbox.html#json_clear/4"},{"type":"function","title":"Cache.Sandbox.json_delete/4","doc":"","ref":"Cache.Sandbox.html#json_delete/4"},{"type":"function","title":"Cache.Sandbox.json_get/4","doc":"","ref":"Cache.Sandbox.html#json_get/4"},{"type":"function","title":"Cache.Sandbox.json_incr/5","doc":"","ref":"Cache.Sandbox.html#json_incr/5"},{"type":"function","title":"Cache.Sandbox.json_set/5","doc":"","ref":"Cache.Sandbox.html#json_set/5"},{"type":"function","title":"Cache.Sandbox.pipeline/3","doc":"","ref":"Cache.Sandbox.html#pipeline/3"},{"type":"function","title":"Cache.Sandbox.pipeline!/3","doc":"","ref":"Cache.Sandbox.html#pipeline!/3"},{"type":"function","title":"Cache.Sandbox.scan/3","doc":"","ref":"Cache.Sandbox.html#scan/3"},{"type":"module","title":"Cache.SandboxRegistry","doc":"This module is used to start the sandbox registry and register caches in test mode More details soon...","ref":"Cache.SandboxRegistry.html"},{"type":"function","title":"Cache.SandboxRegistry.find!/2","doc":"","ref":"Cache.SandboxRegistry.html#find!/2"},{"type":"function","title":"Cache.SandboxRegistry.register_caches/2","doc":"","ref":"Cache.SandboxRegistry.html#register_caches/2"},{"type":"function","title":"Cache.SandboxRegistry.start/1","doc":"","ref":"Cache.SandboxRegistry.html#start/1"},{"type":"function","title":"Cache.SandboxRegistry.start_link/0","doc":"","ref":"Cache.SandboxRegistry.html#start_link/0"}]